# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.Transaction do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :userId,
    :propertyId,
    :type,
    :detailsViewed,
    :imagesViewed,
    :timeToDecision,
    :filter,
    :session,
    :updatedAt,
    :createdAt,
    :User,
    :Property
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :userId => integer() | nil,
    :propertyId => integer() | nil,
    :type => String.t | nil,
    :detailsViewed => boolean() | nil,
    :imagesViewed => integer() | nil,
    :timeToDecision => integer() | nil,
    :filter => String.t | nil,
    :session => String.t | nil,
    :updatedAt => Date.t | nil,
    :createdAt => Date.t | nil,
    :User => FoyerAPI.Model.User.t | nil,
    :Property => FoyerAPI.Model.Property.t | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.Transaction do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:updatedAt, :date, nil, options)
    |> deserialize(:createdAt, :date, nil, options)
    |> deserialize(:User, :struct, FoyerAPI.Model.User, options)
    |> deserialize(:Property, :struct, FoyerAPI.Model.Property, options)
  end
end

